import subprocess


def get_logged_sessions():
    process = subprocess.run(
        ["loginctl", "list-sessions", "--no-legend"], capture_output=True
    )
    session_list = process.stdout.decode().strip().splitlines()

    def get_id(s):
        return s.split(" ")[0]

    return list(map(get_id, session_list))


def get_active_session_username():
    session_ids = get_logged_sessions()

    for s in session_ids:
        process = subprocess.run(
            [
                "loginctl",
                "show-session",
                "-p",
                "Name",
                "-p",
                "State",
                "--value",
                s,
            ],
            capture_output=True,
        )
        session_info = process.stdout.decode().splitlines()
        if len(session_info) >= 2:
            user_name = session_info[0]
            user_state = session_info[1]
        else:
            return None

        if user_state == "active":
            return user_name

    return None
